class LSystem{
  String axiom="X";
  float weight=10.0;
  float brightness=10;
  float hue=0;
  String[][] rules ={{"X","F[--FF][-F]F[+F]F"},
                    {"A","F","FF","F[u+FFFd][u-FFFd]","F[u+FFFd][u-FFFd]"},
                    {"F","F","FF","F[u+FFFd][u-FFFd]","F[u+FFFd][u-FFFd]"},
                    {"+","+"},
                    {"-","-"},
                    {"[","["},
                    {"]","]"}};
  String computedWord;
  int iterations;
  float size,angle,scaleFactor;
  LSystem(float size,float angle,float scaleFactor){
    computedWord=axiom;
    iterations=0;
    this.size=size;
    this.angle=angle;
    this.scaleFactor=scaleFactor;    
  }
  
  void drawLSystem(Turtle t){
    // loop through computedWord and draw each symbol
    char s;
    for(int i=0;i<computedWord.length();i++){
      s=computedWord.charAt(i);
      if(s=='F'){
        t.forward(size/4);
        strokeWeight(weight);
        stroke(hue,100,brightness);
      }else if(s=='+'){
        t.right(angle);
      }else if(s=='-'){
        t.left(angle);
      }else if(s=='['){
        t.push();
      }else if(s==']'){
        t.pop();
      }else if(s=='A'){
        strokeWeight(weight);
        stroke(hue,100,brightness);
        t.forward(size);
      }else if (s=='u'){
        weight*=0.8;
        brightness+=1.5;
        hue=(hue+10)%360;
      }else if (s=='d'){
        weight*=(1.0/0.8);
        brightness*=(1.0/1.5);
        hue=((hue+10)+360)%360;
      }
    }
  }
  
  void iteration(){
    //loop through computedWord
    //for every symbol, check if a rule applies
    //replace symbol according to rule
    size=size*scaleFactor;
    String newWord="";
    char s;
    for(int i=0;i<computedWord.length();i++){
      s=computedWord.charAt(i);
      for(int j=0;j<rules.length;j++){
        if(s==rules[j][0].charAt(0)){
          print(s);
          if(s=='F'){
            newWord=newWord+rules[j][(int)random(1,4)];
           
            break;
          }else{          
             newWord=newWord+rules[j][1];
            break;
          }
           
        }
      }
    }
    iterations++;
    computedWord=newWord;
    println(computedWord+": "+iterations);
    
  }
  
}
