class LSystem{
  String axiom="X";
  float weight=10.0;
  float brightness=10;
  float hue=0;
  String[][] rules ={{"X","[---F][X][--F][X][-F][X][+F][X][++F][X][+++F][X]]","[---F][X][--F][X][-F][X][+F][X][++F][X][+++F][X]]","[---F][X][--F][X][-F][X][+F][X][++F][X][+++F][X]]"},
                    {"F","FF","F-F","F+F"},                    
                    {"+","+","+","+"},
                    {"-","-","-","-"},
                    {"[","[","[","["},
                    {"]","]","]","]"}};
  String computedWord;
  int iterations;
  float size,angle,scaleFactor;
  LSystem(float size,float angle,float scaleFactor){
    computedWord=axiom;
    iterations=0;
    this.size=size;
    this.angle=angle;
    this.scaleFactor=scaleFactor;    
  }
  
  void drawLSystem(Turtle t){
    // loop through computedWord and draw each symbol
    char s;
    for(int i=0;i<computedWord.length();i++){
      s=computedWord.charAt(i);
      if(s=='F'){
        float l=random(0,1)*size;
        t.forward(l);
        strokeWeight(weight);
        weight=weight-weight*0.1;
        stroke(hue,100,brightness);
        hue=((hue+10)+360)%360;
      }else if(s=='+'){
        t.right(angle);
      }else if(s=='-'){
        t.left(angle);
        angle=random(0,1)*30;
      }else if(s=='['){
        t.push();
      }else if(s==']'){
        t.pop();
      }else if(s=='Z'){
        t.forward(size);
      }
    }
  }
  
  void iteration(){
    //loop through computedWord
    //for every symbol, check if a rule applies
    //replace symbol according to rule
    size=size*scaleFactor;
    String newWord="";
    char s;
    for(int i=0;i<computedWord.length();i++){
      s=computedWord.charAt(i);
      for(int j=0;j<rules.length;j++){
        if(s==rules[j][0].charAt(0)){
          print(s);
          if(s=='F'){
            newWord=newWord+rules[j][(int)random(1,4)];
           
            break;
          }else{          
             newWord=newWord+rules[j][1];
            break;
          }
           
        }
      }
    }
    iterations++;
    computedWord=newWord;
    println(computedWord+": "+iterations);
    
  }
  
}
