class LSystem{
  String axiom="Y";
  float weight=50.0;
  float brightness=100;
  float hue=10;
  String[][] rules ={{"Y","XY[+YFF]Y[-YFF]Y"},
                    {"X","X[-FY][+FY]FX"},
                    {"+","+"},
                    {"-","-"},
                    {"[","["},
                    {"]","]"}};
                    
  String computedWord;
  int iterations;
  float size,angle,scaleFactor;

  
  LSystem(float size,float angle,float scaleFactor){
    computedWord=axiom;
    iterations=0;
    this.size=size;
    this.angle=angle;
    this.scaleFactor=scaleFactor;    
  }
  
  void drawLSystem(Turtle t){
    // loop through computedWord and draw each symbol
    char s;
    for(int i=0;i<computedWord.length();i++){
      s=computedWord.charAt(i);
      if(s=='F'){
        t.forward(size);
        strokeWeight(weight);
        stroke(hue,100,brightness);
      }else if(s=='+'){
        t.right(angle);
      }else if(s=='-'){
        t.left(angle);
      }else if(s=='['){
        t.push();
      }else if(s==']'){
        t.pop();
      }else if(s=='Z'){
        t.forward(size);
      }else if(s=='X'){
        weight=20;
      }
      else if(s=='Y'){
        weight=1;
      }
    }
  }
  
  void iteration(){
    //loop through computedWord
    //for every symbol, check if a rule applies
    //replace symbol according to rule
    size=size*scaleFactor;
    String newWord="";
    char s;
    for(int i=0;i<computedWord.length();i++){
      s=computedWord.charAt(i);
      for(int j=0;j<rules.length;j++){
        if(s==rules[j][0].charAt(0)){
          print(s);
          if(s=='F'){
            newWord=newWord+rules[j][1];
           
            break;
          }else{          
             newWord=newWord+rules[j][1];
            break;
          }
           
        }
      }
    }
    iterations++;
    computedWord=newWord;
    println(computedWord+": "+iterations);
    
  }
  
}
